/**
 * @function doSignin
 * @returns Promise
 */

"use strict";

function doSignin(User, Sign, data, digest) {
    return Sign
        .findAll({where: {key: data.key}, limit: 1})
        .then((signs) => {
            return signs && signs.shift();
        })
        .then((sign) => {
            if (!sign) {
                return null;
            }
            return digest(data.password, sign.salt)
                .then((hash) => {
                    return sign && sign.hash === hash;
                })
                .then((valid) => {
                    if (!valid) {
                        return null;
                    }
                    return User
                        .findById(sign.get('id'))
                        .then((user) => {
                            return sign
                                .update({
                                    signin_at: new Date()
                                })
                                .then((sign) => {
                                    let result = sign.toJSON();
                                    result.user = user.toJSON();
                                    return result;
                                });
                        });
                });
        });
}

module.exports = doSignin;

